#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include "QUANTAinit.hxx"
#include "QUANTAts_thread_c.hxx"
#ifndef WIN32
#include <unistd.h>
#endif

#define CYCLES 5

void* threadFunc1(void* data)
{
	for (int i = 0; i < CYCLES; i++)
	{
		printf("thread1 cycle count = %d\n", i);
#ifdef WIN32
		Sleep(1000); // window Sleep
#else
		usleep(1000); // linux usleep
#endif
	}

	return NULL;
}

void* threadFunc2(void* data)
{
	for (int i = 0; i < CYCLES; i++)
	{
		printf("thread2 cycle count = %d\n", i);
#ifdef WIN32
		Sleep(1000); // window Sleep
#else
		usleep(1000); // linux usleep
#endif
	}

	return NULL;
}

void* threadFunc3(void* data)
{
	for (int i = 0; i < CYCLES; i++)
	{
		printf("thread3 cycle count = %d\n", i);
#ifdef WIN32
		Sleep(1000); // window Sleep
#else
		usleep(1000); // linux usleep
#endif
	}

	return NULL;
}

int main(int argc, char** argv)
{
	QUANTAinit();
	QUANTAts_thread_c thread;

	thread.create(threadFunc1, (void*)NULL);
	thread.create(threadFunc2, (void*)NULL);
	thread.create(threadFunc3, (void*)NULL);

	for (int i = 0; i < 2* CYCLES; i++)
	{
		printf("main cycle count = %d\n", i);
#ifdef WIN32
		Sleep(1000); // window Sleep
#else
		usleep(1000); // linux usleep
#endif
	}

	return 0;
}